"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "useOutputCard_unstable", {
    enumerable: true,
    get: function() {
        return useOutputCard_unstable;
    }
});
const _interop_require_wildcard = require("@swc/helpers/_/_interop_require_wildcard");
const _react = /*#__PURE__*/ _interop_require_wildcard._(require("react"));
const _reactcomponents = require("@fluentui/react-components");
const _reactprovider = require("@fluentui-copilot/react-provider");
const _reactflair = require("@fluentui-copilot/react-flair");
const _reactutilities = require("@fluentui/react-utilities");
const useOutputCard_unstable = (props, ref)=>{
    const { play, targetRef, ...flairProps } = (0, _reactflair.useFlair)();
    const designVersion = (0, _reactprovider.useDesignVersion)(props.designVersion);
    var _props_isLoading;
    const state = {
        flairClassName: flairProps.className,
        designVersion,
        isLoading: (_props_isLoading = props.isLoading) !== null && _props_isLoading !== void 0 ? _props_isLoading : false,
        mode: (0, _reactprovider.useCopilotMode)(props.mode),
        components: {
            root: 'div',
            progress: _reactcomponents.ProgressBar
        },
        root: _reactcomponents.slot.always({
            ...(0, _reactcomponents.getIntrinsicElementProps)('div', {
                ref: (0, _reactcomponents.useMergedRefs)(targetRef, ref),
                ...props
            }),
            style: {
                ...flairProps.style,
                ...props.style
            }
        }, {
            elementType: 'div'
        }),
        progress: _reactcomponents.slot.optional(props.progress, {
            defaultProps: {
                shape: 'square',
                thickness: 'large',
                'aria-label': 'Loading'
            },
            elementType: _reactcomponents.ProgressBar,
            renderByDefault: false
        })
    };
    const previousIsLoading = (0, _reactutilities.usePrevious)(state.isLoading);
    _react.useEffect(()=>{
        if (!state.isLoading && previousIsLoading) {
            play();
        }
    }, [
        state.isLoading,
        previousIsLoading,
        play
    ]);
    return state;
};
