// eslint-disable
"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
function _export(target, all) {
    for(var name in all)Object.defineProperty(target, name, {
        enumerable: true,
        get: all[name]
    });
}
_export(exports, {
    outputCardClassNames: function() {
        return outputCardClassNames;
    },
    useOutputCardStyles_unstable: function() {
        return useOutputCardStyles_unstable;
    }
});
const _reactcomponents = require("@fluentui/react-components");
const _tokens = require("@fluentui-copilot/tokens");
const outputCardClassNames = {
    root: 'fai-OutputCard',
    progress: 'fai-OutputCard__progress'
};
const indeterminateProgressBarReducedMotion = {
    '0%': {
        opacity: '.2'
    },
    '50%': {
        opacity: '1'
    },
    '100%': {
        opacity: '.2'
    }
};
/**
 * Styles for the root slot
 */ const useStyles = (0, _reactcomponents.makeStyles)({
    root: {
        borderRadius: _tokens.tokens.borderRadiusXLarge,
        display: 'flex',
        flexDirection: 'column',
        position: 'relative',
        zIndex: 0,
        backgroundColor: _tokens.tokens.colorNeutralBackground1,
        boxSizing: 'border-box',
        boxShadow: _tokens.tokens.shadow4,
        // to ensure a visible border in high contrast mode
        outline: `1px solid ${_tokens.tokens.colorTransparentStroke}`
    },
    sidecar: {
        padding: `${_tokens.tokens.spacingVerticalM} ${_tokens.tokens.spacingHorizontalL}`
    },
    canvas: {
        padding: `${_tokens.tokens.spacingVerticalL} ${_tokens.tokens.spacingVerticalXL}`
    },
    progressRoot: {
        overflow: 'hidden',
        width: 'auto',
        overflowX: 'hidden',
        overflowY: 'hidden',
        position: 'absolute',
        bottom: 0,
        left: 0,
        right: 0,
        height: 0,
        borderBottomLeftRadius: _tokens.tokens.borderRadiusLarge,
        borderBottomRightRadius: _tokens.tokens.borderRadiusLarge,
        clipPath: 'polygon(0px 4px, 100% 4px, 100% 8px, 0px 8px)',
        transition: `height ${_tokens.tokens.durationSlow} ${_tokens.tokens.curveDecelerateMin}`
    },
    progressIsLoading: {
        height: '8px'
    },
    bar: {
        borderRadius: 0
    },
    regularProgressBarStyles: {
        height: '100%',
        backgroundImage: `linear-gradient(90deg, ${_tokens.tokens.colorBrandFlair1} 35%, ${_tokens.tokens.colorBrandFlair2} 70%, ${_tokens.tokens.colorBrandFlair3} 92%)`
    },
    indeterminateProgressBarStyles: {
        animationDuration: '3s',
        height: '100%',
        backgroundColor: _tokens.tokens.colorTransparentBackground,
        backgroundImage: `linear-gradient(90deg, rgba(0,0,0,0) 0%, ${_tokens.tokens.colorBrandFlair1} 35%, ${_tokens.tokens.colorBrandFlair2} 70%, ${_tokens.tokens.colorBrandFlair3} 92%,  rgba(0,0,0,0))`,
        '@media screen and (prefers-reduced-motion: reduce)': {
            maxWidth: '100%',
            animationIterationCount: 'infinite',
            animationName: indeterminateProgressBarReducedMotion,
            animationDuration: '3s'
        }
    },
    indeterminateBarNotIsLoading: {
        animationPlayState: 'paused'
    }
});
const useNextStyles = (0, _reactcomponents.makeStyles)({
    root: {
        padding: `${_tokens.tokens.spacingVerticalXXL} ${_tokens.tokens.spacingHorizontalXXL}`,
        borderRadius: _tokens.tokens.borderRadius4XL
    },
    progressRoot: {
        borderBottomLeftRadius: _tokens.tokens.borderRadius4XL,
        borderBottomRightRadius: _tokens.tokens.borderRadius4XL,
        // Given that the border radius is 24px and the height of the progress bar is 4px,
        // if you find the intersection between a circle centered at x=0, y=24 with radius
        // 24px and the line y=4, you find that the intersection occurs at x=13.266 which
        // makes the offset approximately 10px.
        right: '10px',
        left: '10px'
    }
});
const useOutputCardStyles_unstable = (state)=>{
    'use no memo';
    const { flairClassName, designVersion } = state;
    const styles = useStyles();
    const nextStyles = useNextStyles();
    state.root.className = (0, _reactcomponents.mergeClasses)(outputCardClassNames.root, styles.root, styles[state.mode], flairClassName, designVersion === 'next' && nextStyles.root, state.root.className);
    if (state.progress) {
        state.progress.className = (0, _reactcomponents.mergeClasses)(outputCardClassNames.progress, styles.progressRoot, state.isLoading && styles.progressIsLoading, designVersion === 'next' && nextStyles.progressRoot, state.progress.className);
        const bar = _reactcomponents.slot.optional(state.progress.bar, {
            elementType: 'div',
            renderByDefault: true
        });
        if (bar) {
            if (state.progress.value === undefined) {
                bar.className = (0, _reactcomponents.mergeClasses)(styles.bar, styles.indeterminateProgressBarStyles, !state.isLoading && styles.indeterminateBarNotIsLoading, bar.className);
            } else {
                bar.className = (0, _reactcomponents.mergeClasses)(styles.regularProgressBarStyles, styles.bar, bar.className);
            }
            state.progress.bar = bar;
        }
    }
    return state;
};
